package com.engine.salary.service;

import com.engine.salary.entity.salaryacct.po.SalaryAcctResultLogPO;

import java.util.Collection;
import java.util.List;

/**
 * @author Harryxzy
 * @date 2023/05/12 15:27
 * @description 薪资核算结果数据来源
 */
public interface SalaryAcctResultLogService {

    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    List<SalaryAcctResultLogPO> listAll();


    /**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
    SalaryAcctResultLogPO getById(Long id);


    /**
     * 新增，忽略null字段
     *
     * @param salaryAcctResultLog 新增的记录
     * @return 返回影响行数
     */
    int insertIgnoreNull(SalaryAcctResultLogPO salaryAcctResultLog);

    /**
     * 修改，修改所有字段
     *
     * @param salaryAcctResultLog 修改的记录
     * @return 返回影响行数
     */
    int update(SalaryAcctResultLogPO salaryAcctResultLog);

    /**
     * 修改，忽略null字段
     *
     * @param salaryAcctResultLog 修改的记录
     * @return 返回影响行数
     */
    int updateIgnoreNull(SalaryAcctResultLogPO salaryAcctResultLog);

    /**
     * 删除记录
     *
     * @param salaryAcctResultLog 待删除的记录
     * @return 返回影响行数
     */
    int delete(SalaryAcctResultLogPO salaryAcctResultLog);

    void batchInsert(List<SalaryAcctResultLogPO> salaryAcctResultLogList);

    /**
     * 根据薪资核算人员删除数据，除了已经锁定的值
     * @param salaryAcctEmployeeIds
     * @param lockSalaryItemIds
     */
    void deleteBySalaryAcctEmpIdExceptItemIds(List<Long> salaryAcctEmployeeIds, Collection<Long> lockSalaryItemIds);
}
